﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using HLWebOKBAdminPlugin.OKBAdministrationService;
using HLWebOKBAdminPlugin.Helpers;

namespace HLWebOKBAdminPlugin.Models {
  public class PlatformModel {
    public String SelectedSubMenu { get; set; }
    public IList<Platform> Platforms {
      get { return PlatformGetAll(); }
      set { ;}
    }

    public Platform Platform { get; set; }

    public PlatformModel() {
      Platform = new Platform();
    }//PlatformModel

    //***************************************Platform Class**********************************************
    private IList<Platform> PlatformGetAll() {
      AdministrationServiceClient adminClient = Admin.GetClientFactory();

      IList<Platform> platformList = new List<Platform>();

      if (adminClient != null) {
        Platform[] platforms = adminClient.GetPlatforms();
        foreach (Platform pl in platforms) {
          platformList.Add(pl);
        }
      }//if (adminClient != null)

      return platformList;
    }//ProblemClassGetAll                

    private long AddPlatform(Platform plattform) {
      AdministrationServiceClient adminClient = Admin.GetClientFactory();

      if (adminClient != null) {
        return adminClient.AddPlatform(plattform);
      }

      return 0;
    }//AddPlatform

    public void DeletePlatform(long id) {
      AdministrationServiceClient adminClient = Admin.GetClientFactory();

      if (adminClient != null) {
        adminClient.DeletePlatform(id);
      }
    }//DeletePlatform

    public long SavePlatform(Platform platform) {
      AdministrationServiceClient adminClient = Admin.GetClientFactory();

      if (adminClient != null) {
        if (platform.Id == 0) {
          return AddPlatform(platform);
        } else {
          Platform pl = adminClient.GetPlatform(platform.Id);

          if (pl != null) {
            adminClient.UpdatePlatform(platform);
            return platform.Id;
          }
        }
      }

      return 0;
    }//SavePlatform        
  }
}